include \masm32\include\masm32rt.inc

IDC_REBAR1    equ 2
IDC_EDJ1     equ 3
IDC_EDJ2     equ 4
IDC_EDJ3     equ 5
IDC_EDJ4     equ 6
IDC_EDJ5     equ 7

insChild2 = 1	; test inserting the second edit

CStr macro y:vararg
local sym,xxx
	.const
sym db y,0
	.code
	exitm <offset sym>
	endm

	.data

g_hInstance		HINSTANCE 0
g_hwndMain		HWND 0
g_hwndRebar1	HWND 0
g_hwndEdit1		HWND 0
g_hwndEdit2		HWND 0
g_hwndEdit3		HWND 0
g_hwndEdit4		HWND 0
g_hwndEdit5		HWND 0

	.code

OnSize proc uses ebx hWnd:HWND, wParam:WPARAM, lParam:LPARAM

LOCAL rect:RECT

	mov eax,wParam
	.if (eax == SIZE_RESTORED || eax == SIZE_MAXIMIZED)

		invoke GetClientRect, hWnd, addr rect
		MyWidth = 48
	if 0
		invoke SetWindowPos, g_hwndRebar1, NULL, 0, 0,
			MyWidth, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit1, NULL, 50, 0,
			MyWidth, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit2, NULL, 100, 0,
			MyWidth, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit3, NULL, 150, 0,
			MyWidth, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit4, NULL, 200, 0,
			MyWidth, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit5, NULL, 250, 0,
			MyWidth, 24, SWP_NOZORDER or SWP_NOACTIVATE

	else
		sub rect.right, 2
		invoke SetWindowPos, g_hwndRebar1, NULL, 0, 0,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE

		mov eax, rect.right
		sub eax, 50
		invoke SetWindowPos, g_hwndEdit1, NULL, 50, 0,
			eax, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit2, NULL, 0, 32,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit3, NULL, 0, 64,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit4, NULL, 0, 96,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit5, NULL, 0, 128,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE
	endif

	.endif
	ret
	align 4

OnSize endp

;*** the main window proc

DlgProc proc hWnd:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM

	mov eax,uMsg
	.if (eax == WM_INITDIALOG)
		xor eax, eax
	.elseif (eax == WM_CLOSE)
		invoke DestroyWindow, hWnd
	.elseif (eax == WM_DESTROY)
		invoke PostQuitMessage,NULL
	.elseif (eax == WM_SIZE)
		invoke OnSize, hWnd, wParam, lParam
		mov eax, 1
	.elseif (eax == WM_COMMAND)
		.if ( wParam == IDCANCEL )
			invoke PostMessage, hWnd, WM_CLOSE, 0, 0
		.endif
		mov eax, 1
	.else
		xor eax, eax
	.endif
	ret
	align 4

DlgProc endp

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, lpszCmdLine:LPSTR, iCmdShow:dword
LOCAL ccsex:INITCOMMONCONTROLSEX
LOCAL msg:MSG
LOCAL rbbi:REBARBANDINFO

	mov ccsex.dwSize, sizeof INITCOMMONCONTROLSEX
	mov ccsex.dwICC, ICC_BAR_CLASSES
	invoke InitCommonControlsEx, addr ccsex

;--- create modeless dialog

	invoke CreateDialogParam, hInst, 1, NULL, DlgProc, 0
	mov g_hwndMain, eax
	.if (!eax)
		invoke MessageBox, 0, CStr("CreateDialogParam failed"), 0, MB_OK
		ret
	.endif
	invoke GetDlgItem, g_hwndMain, IDC_REBAR1
	mov g_hwndRebar1, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDJ1
	mov g_hwndEdit1, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDJ2
	mov g_hwndEdit2, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDJ3
	mov g_hwndEdit3, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDJ4
	mov g_hwndEdit4, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDJ5
	mov g_hwndEdit5, eax

;--- place first edit into rebar

	mov rbbi.cbSize, SIZEOF REBARBANDINFO
	mov rbbi.fMask, RBBIM_CHILD or RBBIM_SIZE or RBBIM_STYLE or RBBIM_CHILDSIZE or RBBIM_TEXT or RBBIM_ID
	mov rbbi.lpText, CStr("rebar1")

	mov eax, g_hwndEdit1
	mov rbbi.hwndChild,eax
	mov rbbi.fStyle, RBBS_GRIPPERALWAYS + RBBS_CHILDEDGE
;	mov rbbi.cx_,100
	mov rbbi.cxMinChild,100
	mov rbbi.cyChild,24
	mov rbbi.cyMinChild,24
	mov rbbi.wID,IDC_EDJ1
	invoke SendMessage,g_hwndRebar1, RB_INSERTBAND,-1,addr rbbi

	if insChild2
	mov eax, g_hwndEdit2
	mov rbbi.hwndChild,eax
	mov rbbi.fStyle, RBBS_GRIPPERALWAYS + RBBS_CHILDEDGE
;	mov rbbi.cx_,100
	mov rbbi.cxMinChild,200
	mov rbbi.cyChild,24
	mov rbbi.cyMinChild,24
	mov rbbi.wID,IDC_EDJ2
	invoke SendMessage,g_hwndRebar1, RB_INSERTBAND,-1,addr rbbi
	endif

	invoke ShowWindow, g_hwndMain, SW_NORMAL
	
	.while (1)
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if (eax == 0)
		invoke IsDialogMessage, g_hwndMain, ADDR msg
		.continue .if eax
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage,  ADDR msg
	.endw
exit:
	mov eax, msg.wParam
	ret
	align 4

WinMain endp


start proc public

	invoke GetModuleHandle, NULL
	mov g_hInstance, eax

	invoke WinMain, g_hInstance, 0, NULL, 0

	invoke ExitProcess,eax

start endp

	end start
